************************ ADJUSTMENTS ******************************/

GtkObject* gtk_adjustment_new			(gfloat		  value,
						 gfloat		  lower,
						 gfloat		  upper,
						 gfloat		  step_increment,
						 gfloat		  page_increment,
						 gfloat		  page_size);
void	   gtk_adjustment_changed		(GtkAdjustment	 *adjustment);
void	   gtk_adjustment_value_changed		(GtkAdjustment	 *adjustment);
void	   gtk_adjustment_clamp_page		(GtkAdjustment	 *adjustment,
						 gfloat		  lower,
						 gfloat		  upper);
void	   gtk_adjustment_set_value		(GtkAdjustment	 *adjustment,
						 gfloat		  value);


/************************ BOXES ************************************/

void	   gtk_box_pack_start	       (GtkBox	     *box,
					GtkWidget    *child,
					gboolean      expand,
					gboolean      fill,
					guint	      padding);
void	   gtk_box_pack_end	       (GtkBox	     *box,
					GtkWidget    *child,
					gboolean      expand,
					gboolean      fill,
					guint	      padding);
void	   gtk_box_pack_start_defaults (GtkBox	     *box,
					GtkWidget    *widget);
void	   gtk_box_pack_end_defaults   (GtkBox	     *box,
					GtkWidget    *widget);
void	   gtk_box_set_homogeneous     (GtkBox	     *box,
					gboolean      homogeneous);
void	   gtk_box_set_spacing	       (GtkBox	     *box,
					gint	      spacing);
void	   gtk_box_reorder_child       (GtkBox	     *box,
					GtkWidget    *child,
					gint	      position);
void	   gtk_box_query_child_packing (GtkBox	     *box,
					GtkWidget    *child,
					gboolean     *expand,
					gboolean     *fill,
					guint	     *padding,
					GtkPackType  *pack_type);
void	   gtk_box_set_child_packing   (GtkBox	     *box,
					GtkWidget    *child,
					gboolean      expand,
					gboolean      fill,
					guint	      padding,
					GtkPackType   pack_type);


/******************** CONTAINERS ***********************************/

void    gtk_container_border_width	 (GtkContainer	   *container,
					  guint		    border_width);
void    gtk_container_add		 (GtkContainer	   *container,
					  GtkWidget	   *widget);
void    gtk_container_remove		 (GtkContainer	   *container,
					  GtkWidget	   *widget);

void    gtk_container_set_resize_mode    (GtkContainer     *container,
					  GtkResizeMode     resize_mode);

void    gtk_container_check_resize       (GtkContainer     *container);

void    gtk_container_foreach		 (GtkContainer	   *container,
					  GtkCallback	    callback,
					  gpointer	    callback_data);
void    gtk_container_foreach_interp	 (GtkContainer	   *container,
					  GtkCallbackMarshal marshal,
					  gpointer	    callback_data,
					  GtkDestroyNotify  notify);
void    gtk_container_foreach_full	 (GtkContainer	   *container,
					  GtkCallback	    callback,
					  GtkCallbackMarshal marshal,
					  gpointer	    callback_data,
					  GtkDestroyNotify  notify);
GList* gtk_container_children		 (GtkContainer	   *container);
gint   gtk_container_focus		   (GtkContainer     *container,
					    GtkDirectionType  direction);

/********************** DRAWING AREAS *************************/

GtkWidget* gtk_drawing_area_new        (void);
void       gtk_drawing_area_size       (GtkDrawingArea      *darea,
					gint                 width,
					gint                 height);

/********************** ENTRIES ***********************************/

GtkWidget* gtk_entry_new            		(void);
GtkWidget* gtk_entry_new_with_max_length	(guint16   max);
void       gtk_entry_set_text       		(GtkEntry      *entry,
						 const gchar   *text);
void       gtk_entry_append_text    		(GtkEntry      *entry,
						 const gchar   *text);
void       gtk_entry_prepend_text   		(GtkEntry      *entry,
						 const gchar   *text);
void       gtk_entry_set_position   		(GtkEntry      *entry,
						 gint           position);
gchar*     gtk_entry_get_text       		(GtkEntry      *entry);
void       gtk_entry_select_region  		(GtkEntry      *entry,
						 gint           start,
						 gint           end);
void       gtk_entry_set_visibility 		(GtkEntry      *entry,
						 gboolean       visible);
void       gtk_entry_set_editable   		(GtkEntry      *entry,
						 gboolean       editable);
/* DO NOT USE THIS FUNCTION. The only reason why it is public
 * is that there were bugs in GtkEntry. IT WILL DISAPPEAR. */
void       gtk_entry_adjust_scroll  		(GtkEntry      *entry);
/* text is truncated if needed */
void       gtk_entry_set_max_length 		(GtkEntry      *entry,
						 guint16        max);


/************************ FRAMES ******************************/

GtkWidget* gtk_frame_new             (const gchar   *label);
void       gtk_frame_set_label       (GtkFrame      *frame,
				      const gchar   *label);
void       gtk_frame_set_label_align (GtkFrame      *frame,
				      gfloat         xalign,
				      gfloat         yalign);
void       gtk_frame_set_shadow_type (GtkFrame      *frame,
				      GtkShadowType  type);


/**************************** LABELS *********************/

GtkType	   gtk_label_get_type	 (void);
GtkWidget* gtk_label_new	 (const gchar	    *string);
void	   gtk_label_set	 (GtkLabel	    *label,
				  const gchar	    *string);
void	   gtk_label_set_pattern (GtkLabel	    *label,
				  const gchar	    *pattern);
void	   gtk_label_set_justify (GtkLabel	    *label,
				  GtkJustification   jtype);
void	   gtk_label_get	 (GtkLabel	    *label,
				  gchar		   **string);


/* Convenience function to set the name and pattern by parsing
 * a string with embedded underscores, and return the appropriate
 * key symbol for the accelerator.
 */

/****************** MENU BAR ***************************/

guint      gtk_label_parse_uline    (GtkLabel         *label,


GtkWidget* gtk_menu_bar_new      (void);
void       gtk_menu_bar_append   (GtkMenuBar *menu_bar,
				  GtkWidget  *child);
void       gtk_menu_bar_prepend  (GtkMenuBar *menu_bar,
				  GtkWidget  *child);
void       gtk_menu_bar_insert   (GtkMenuBar *menu_bar,
				  GtkWidget  *child,
				  gint        position);

/*************************** NOTEBOOKS ****************************/

GtkWidget* gtk_notebook_new             (void);
void       gtk_notebook_append_page       (GtkNotebook      *notebook,
				           GtkWidget        *child,
				           GtkWidget        *tab_label);
void       gtk_notebook_append_page_menu  (GtkNotebook      *notebook,
					   GtkWidget        *child,
					   GtkWidget        *tab_label,
					   GtkWidget        *menu_label);
void       gtk_notebook_prepend_page      (GtkNotebook      *notebook,
				           GtkWidget        *child,
				           GtkWidget        *tab_label);
void       gtk_notebook_prepend_page_menu (GtkNotebook      *notebook,
					   GtkWidget        *child,
					   GtkWidget        *tab_label,
					   GtkWidget        *menu_label);
void       gtk_notebook_insert_page       (GtkNotebook      *notebook,
				           GtkWidget        *child,
				           GtkWidget        *tab_label,
				           gint              position);
void       gtk_notebook_insert_page_menu  (GtkNotebook      *notebook,
				           GtkWidget        *child,
				           GtkWidget        *tab_label,
					   GtkWidget        *menu_label,
				           gint              position);
void       gtk_notebook_remove_page       (GtkNotebook      *notebook,
				           gint              page_num);
gint       gtk_notebook_current_page      (GtkNotebook      *notebook);
gint	   gtk_notebook_page_num	  (GtkNotebook	    *notebook,
					   GtkWidget	    *child);
void       gtk_notebook_set_page          (GtkNotebook      *notebook,
				           gint              page_num);
void       gtk_notebook_next_page         (GtkNotebook      *notebook);
void       gtk_notebook_prev_page         (GtkNotebook      *notebook);
void       gtk_notebook_reorder_child     (GtkNotebook      *notebook,
					   GtkWidget        *child,
					   gint              position);
void       gtk_notebook_set_tab_pos       (GtkNotebook      *notebook,
					   GtkPositionType   pos);
void       gtk_notebook_set_show_tabs     (GtkNotebook      *notebook,
					   gboolean          show_tabs);
void       gtk_notebook_set_show_border   (GtkNotebook      *notebook,
					   gint              show_border);
void       gtk_notebook_set_scrollable    (GtkNotebook      *notebook,
					   gint              scrollable);
void       gtk_notebook_set_tab_border    (GtkNotebook      *notebook,
					   guint             border_width);
void       gtk_notebook_popup_enable      (GtkNotebook      *notebook);
void       gtk_notebook_popup_disable     (GtkNotebook      *notebook);

/************************ PROGRESS ************************/

void       gtk_progress_set_show_text       (GtkProgress   *progress,
					     gint           show_text);
void       gtk_progress_set_text_alignment  (GtkProgress   *progress,
					     gfloat         x_align,
					     gfloat         y_align);
void       gtk_progress_set_format_string   (GtkProgress   *progress,
					     gchar         *format);
void       gtk_progress_set_adjustment      (GtkProgress   *progress,
					     GtkAdjustment *adjustment);
void       gtk_progress_reconfigure         (GtkProgress   *progress,
					     gfloat         value,
					     gfloat         min,
					     gfloat         max);
void       gtk_progress_set_percentage      (GtkProgress   *progress,
					     gfloat         percentage);
void       gtk_progress_set_value           (GtkProgress   *progress,
					     gfloat         value);
gfloat     gtk_progress_get_value           (GtkProgress   *progress);
void       gtk_progress_set_activity_mode   (GtkProgress   *progress,
					     guint          activity_mode);
gchar *    gtk_progress_get_current_text    (GtkProgress   *progress);
gchar *    gtk_progress_get_text_from_value (GtkProgress   *progress,
					     gfloat         value);
gfloat     gtk_progress_get_current_percentage (GtkProgress *progress);
gfloat     gtk_progress_get_percentage_from_value (GtkProgress *progress,

/*********************** PROGRESS BAR **********************/

GtkWidget* gtk_progress_bar_new                  (void);
GtkWidget* gtk_progress_bar_new_with_adjustment  (GtkAdjustment  *adjustment);
void       gtk_progress_bar_construct            (GtkProgressBar *pbar,
						  GtkAdjustment  *adjustment);
void       gtk_progress_bar_set_bar_style        (GtkProgressBar *pbar,
						  GtkProgressBarStyle style);
void       gtk_progress_bar_set_discrete_blocks  (GtkProgressBar *pbar,
						  guint           blocks);
void       gtk_progress_bar_set_activity_step    (GtkProgressBar *pbar,
                                                  guint           step);
void       gtk_progress_bar_set_activity_blocks  (GtkProgressBar *pbar,
						  guint           blocks);
void       gtk_progress_bar_set_orientation      (GtkProgressBar *pbar,
						  GtkProgressBarOrientation orientation);
void       gtk_progress_bar_update               (GtkProgressBar *pbar,
						  gfloat          percentage);


/*********************** RADIOBUTTONS ***********************/

GtkWidget*  gtk_radio_button_new	     (GSList	     *group);
GtkWidget*  gtk_radio_button_new_from_widget (GtkRadioButton *group);
GtkWidget*  gtk_radio_button_new_with_label  (GSList	     *group,
					      const gchar    *label);
GtkWidget*  gtk_radio_button_new_with_label_from_widget (GtkRadioButton *group,
							 const gchar	*label);
GSList*	    gtk_radio_button_group	     (GtkRadioButton *radio_button);
void	    gtk_radio_button_set_group	     (GtkRadioButton *radio_button,
					      GSList	     *group);

/********************** RANGES ****************************/

GtkAdjustment* gtk_range_get_adjustment         (GtkRange      *range);
void           gtk_range_set_update_policy      (GtkRange      *range,
						 GtkUpdateType  policy);
void           gtk_range_set_adjustment         (GtkRange      *range,
						 GtkAdjustment *adjustment);

void           gtk_range_draw_background        (GtkRange      *range);
void           gtk_range_draw_trough            (GtkRange      *range);
void           gtk_range_draw_slider            (GtkRange      *range);
void           gtk_range_draw_step_forw         (GtkRange      *range);
void           gtk_range_draw_step_back         (GtkRange      *range);
void           gtk_range_slider_update          (GtkRange      *range);
gint           gtk_range_trough_click           (GtkRange      *range,
						 gint           x,
						 gint           y,
						 gfloat	       *jump_perc);

void           gtk_range_default_hslider_update (GtkRange      *range);
void           gtk_range_default_vslider_update (GtkRange      *range);
gint           gtk_range_default_htrough_click  (GtkRange      *range,
						 gint           x,
						 gint           y,
						 gfloat	       *jump_perc);
gint           gtk_range_default_vtrough_click  (GtkRange      *range,
						 gint           x,
						 gint           y,
						 gfloat	       *jump_perc);
void           gtk_range_default_hmotion        (GtkRange      *range,
						 gint           xdelta,
						 gint           ydelta);
void           gtk_range_default_vmotion        (GtkRange      *range,
						 gint           xdelta,	
						 gint           ydelta);

/*****************************  RULERS ***************************/

void  gtk_ruler_set_metric (GtkRuler       *ruler,
			    GtkMetricType   metric);
void  gtk_ruler_set_range  (GtkRuler       *ruler,
			    gfloat          lower,
			    gfloat          upper,
			    gfloat          position,
			    gfloat          max_size);
void  gtk_ruler_draw_ticks (GtkRuler       *ruler);
void  gtk_ruler_draw_pos   (GtkRuler       *ruler);

/********************** TABLES ******************************/

GtkWidget* gtk_table_new	      (guint		rows,
				       guint		columns,
				       gboolean		homogeneous);
void	   gtk_table_resize	      (GtkTable	       *table,
				       guint            rows,
				       guint            columns);
void	   gtk_table_attach	      (GtkTable	       *table,
				       GtkWidget       *child,
				       guint		left_attach,
				       guint		right_attach,
				       guint		top_attach,
				       guint		bottom_attach,
				       GtkAttachOptions xoptions,
				       GtkAttachOptions yoptions,
				       guint		xpadding,
				       guint		ypadding);
void	   gtk_table_attach_defaults  (GtkTable	       *table,
				       GtkWidget       *widget,
				       guint		left_attach,
				       guint		right_attach,
				       guint		top_attach,
				       guint		bottom_attach);
void	   gtk_table_set_row_spacing  (GtkTable	       *table,
				       guint		row,
				       guint		spacing);
void	   gtk_table_set_col_spacing  (GtkTable	       *table,
				       guint		column,
				       guint		spacing);
void	   gtk_table_set_row_spacings (GtkTable	       *table,
				       guint		spacing);
void	   gtk_table_set_col_spacings (GtkTable	       *table,
				       guint		spacing);
void	   gtk_table_set_homogeneous  (GtkTable	       *table,
				       gboolean		homogeneous);

/*************************** TOGGLEBOTTONS ***********************/

GtkWidget* gtk_toggle_button_new            (void);
GtkWidget* gtk_toggle_button_new_with_label (const gchar     *label);
void       gtk_toggle_button_set_mode       (GtkToggleButton *toggle_button,
					     gint             draw_indicator);
void       gtk_toggle_button_set_state      (GtkToggleButton *toggle_button,
					     gint             state);
void       gtk_toggle_button_toggled        (GtkToggleButton *toggle_button);

/**************************** TOOLBARS *****************************/

GtkWidget *gtk_toolbar_append_item     (GtkToolbar      *toolbar,
					const char      *text,
					const char      *tooltip_text,
					const char      *tooltip_private_text,
					GtkWidget       *icon,
					GtkSignalFunc    callback,
					gpointer         user_data);
GtkWidget *gtk_toolbar_prepend_item    (GtkToolbar      *toolbar,
					const char      *text,
					const char      *tooltip_text,
					const char      *tooltip_private_text,
					GtkWidget       *icon,
					GtkSignalFunc    callback,
					gpointer         user_data);
GtkWidget *gtk_toolbar_insert_item     (GtkToolbar      *toolbar,
					const char      *text,
					const char      *tooltip_text,
					const char      *tooltip_private_text,
					GtkWidget       *icon,
					GtkSignalFunc    callback,
					gpointer         user_data,
					gint             position);

/* Space Items */
void       gtk_toolbar_append_space    (GtkToolbar      *toolbar);
void       gtk_toolbar_prepend_space   (GtkToolbar      *toolbar);
void       gtk_toolbar_insert_space    (GtkToolbar      *toolbar,
					gint             position);

/* Any element type */
GtkWidget *gtk_toolbar_append_element  (GtkToolbar      *toolbar,
					GtkToolbarChildType type,
					GtkWidget       *widget,
					const char      *text,
					const char      *tooltip_text,
					const char      *tooltip_private_text,
					GtkWidget       *icon,
					GtkSignalFunc    callback,
					gpointer         user_data);

GtkWidget *gtk_toolbar_prepend_element (GtkToolbar      *toolbar,
					GtkToolbarChildType type,
					GtkWidget       *widget,
					const char      *text,
					const char      *tooltip_text,
					const char      *tooltip_private_text,
					GtkWidget       *icon,
					GtkSignalFunc    callback,
					gpointer         user_data);

GtkWidget *gtk_toolbar_insert_element  (GtkToolbar      *toolbar,
					GtkToolbarChildType type,
					GtkWidget       *widget,
					const char      *text,
					const char      *tooltip_text,
					const char      *tooltip_private_text,
					GtkWidget       *icon,
					GtkSignalFunc    callback,
					gpointer         user_data,
					gint             position);

/* Generic Widgets */
void       gtk_toolbar_append_widget   (GtkToolbar      *toolbar,
					GtkWidget       *widget,
					const char      *tooltip_text,
					const char      *tooltip_private_text);
void       gtk_toolbar_prepend_widget  (GtkToolbar      *toolbar,
					GtkWidget       *widget,
					const char      *tooltip_text,
					const char	*tooltip_private_text);
void       gtk_toolbar_insert_widget   (GtkToolbar      *toolbar,
					GtkWidget       *widget,
					const char      *tooltip_text,
					const char      *tooltip_private_text,
					gint             position);

/* Style functions */
void       gtk_toolbar_set_orientation (GtkToolbar      *toolbar,
					GtkOrientation   orientation);
void       gtk_toolbar_set_style       (GtkToolbar      *toolbar,
					GtkToolbarStyle  style);
void       gtk_toolbar_set_space_size  (GtkToolbar      *toolbar,
					gint             space_size);
void       gtk_toolbar_set_tooltips    (GtkToolbar      *toolbar,
					gint             enable);
void       gtk_toolbar_set_button_relief      (GtkToolbar      *toolbar,
					GtkReliefStyle   relief);
GtkReliefStyle gtk_toolbar_get_button_relief  (GtkToolbar      *toolbar);

/************************* WIDGETS *************************/

GtkWidget* gtk_widget_new		  (GtkType		type,
					   const gchar	       *first_arg_name,
					   ...);
GtkWidget* gtk_widget_newv		  (GtkType		type,
					   guint		nargs,
					   GtkArg	       *args);
void	   gtk_widget_ref		  (GtkWidget	       *widget);
void	   gtk_widget_unref		  (GtkWidget	       *widget);
void	   gtk_widget_destroy		  (GtkWidget	       *widget);
void	   gtk_widget_destroyed		  (GtkWidget	       *widget,
					   GtkWidget	      **widget_pointer);
void	   gtk_widget_get		  (GtkWidget	       *widget,
					   GtkArg	       *arg);
void	   gtk_widget_getv		  (GtkWidget	       *widget,
					   guint		nargs,
					   GtkArg	       *args);
void	   gtk_widget_set		  (GtkWidget	       *widget,
					   const gchar         *first_arg_name,
					   ...);
void	   gtk_widget_setv		  (GtkWidget	       *widget,
					   guint		nargs,
					   GtkArg	       *args);
void	   gtk_widget_unparent		  (GtkWidget	       *widget);
void	   gtk_widget_show		  (GtkWidget	       *widget);
void       gtk_widget_show_now            (GtkWidget           *widget);
void	   gtk_widget_hide		  (GtkWidget	       *widget);
void	   gtk_widget_show_all		  (GtkWidget	       *widget);
void	   gtk_widget_hide_all		  (GtkWidget	       *widget);
void	   gtk_widget_map		  (GtkWidget	       *widget);
void	   gtk_widget_unmap		  (GtkWidget	       *widget);
void	   gtk_widget_realize		  (GtkWidget	       *widget);
void	   gtk_widget_unrealize		  (GtkWidget	       *widget);
void	   gtk_widget_queue_draw	  (GtkWidget	       *widget);
void	   gtk_widget_queue_resize	  (GtkWidget	       *widget);
void	   gtk_widget_draw		  (GtkWidget	       *widget,
					   GdkRectangle	       *area);
void	   gtk_widget_draw_focus	  (GtkWidget	       *widget);
void	   gtk_widget_draw_default	  (GtkWidget	       *widget);
void	   gtk_widget_draw_children	  (GtkWidget	       *widget);
void	   gtk_widget_size_request	  (GtkWidget	       *widget,
					   GtkRequisition      *requisition);
void	   gtk_widget_size_allocate	  (GtkWidget	       *widget,
					   GtkAllocation       *allocation);
void	   gtk_widget_add_accelerator	  (GtkWidget           *widget,
					   const gchar         *accel_signal,
					   GtkAccelGroup       *accel_group,
					   guint                accel_key,
					   guint                accel_mods,
					   GtkAccelFlags        accel_flags);
void	   gtk_widget_remove_accelerator  (GtkWidget           *widget,
					   GtkAccelGroup       *accel_group,
					   guint                accel_key,
					   guint                accel_mods);
void	   gtk_widget_remove_accelerators (GtkWidget           *widget,
					   const gchar	       *accel_signal,
					   gboolean		visible_only);
guint	   gtk_widget_accelerator_signal  (GtkWidget           *widget,
					   GtkAccelGroup       *accel_group,
					   guint                accel_key,
					   guint                accel_mods);
void	   gtk_widget_freeze_accelerators (GtkWidget	       *widget);
void	   gtk_widget_thaw_accelerators   (GtkWidget	       *widget);
gint	   gtk_widget_event		  (GtkWidget	       *widget,
					   GdkEvent	       *event);

void	   gtk_widget_activate		  (GtkWidget	       *widget);
void	   gtk_widget_reparent		  (GtkWidget	       *widget,
					   GtkWidget	       *new_parent);
void	   gtk_widget_popup		  (GtkWidget	       *widget,
					   gint			x,
					   gint			y);
gint	   gtk_widget_intersect		  (GtkWidget	       *widget,
					   GdkRectangle	       *area,
					   GdkRectangle	       *intersection);
gint	   gtk_widget_basic		  (GtkWidget	       *widget);

void	   gtk_widget_grab_focus	  (GtkWidget	       *widget);
void	   gtk_widget_grab_default	  (GtkWidget	       *widget);

void	   gtk_widget_set_name		  (GtkWidget	       *widget,
					   const gchar	       *name);
gchar*	   gtk_widget_get_name		  (GtkWidget	       *widget);
void	   gtk_widget_set_state		  (GtkWidget	       *widget,
					   GtkStateType		state);
void	   gtk_widget_set_sensitive	  (GtkWidget	       *widget,
					   gint			sensitive);
void	   gtk_widget_set_parent	  (GtkWidget	       *widget,
					   GtkWidget	       *parent);
void	   gtk_widget_set_parent_window	  (GtkWidget	       *widget,
					   GdkWindow	       *parent_window);
GdkWindow *gtk_widget_get_parent_window	  (GtkWidget	       *widget);
void	   gtk_widget_set_uposition	  (GtkWidget	       *widget,
					   gint			x,
					   gint			y);
void	   gtk_widget_set_usize		  (GtkWidget	       *widget,
					   gint			width,
					   gint			height);
void	   gtk_widget_set_events	  (GtkWidget	       *widget,
					   gint			events);
void	   gtk_widget_set_extension_events (GtkWidget		*widget,
					    GdkExtensionMode	mode);

GdkExtensionMode gtk_widget_get_extension_events (GtkWidget	*widget);
GtkWidget*   gtk_widget_get_toplevel	(GtkWidget	*widget);
GtkWidget*   gtk_widget_get_ancestor	(GtkWidget	*widget,
					 GtkType	widget_type);
GdkColormap* gtk_widget_get_colormap	(GtkWidget	*widget);
GdkVisual*   gtk_widget_get_visual	(GtkWidget	*widget);
gint	     gtk_widget_get_events	(GtkWidget	*widget);
void	     gtk_widget_get_pointer	(GtkWidget	*widget,
					 gint		*x,
					 gint		*y);

gint	     gtk_widget_is_ancestor	(GtkWidget	*widget,
					 GtkWidget	*ancestor);
gint	     gtk_widget_is_child	(GtkWidget	*widget,
					 GtkWidget	*child);

/* Hide widget and return TRUE.
 */
gint	   gtk_widget_hide_on_delete	(GtkWidget	*widget);

/* Widget styles.
 */
void	   gtk_widget_set_style		(GtkWidget	*widget,
					 GtkStyle	*style);
void	   gtk_widget_set_rc_style	(GtkWidget	*widget);
void	   gtk_widget_ensure_style	(GtkWidget	*widget);
GtkStyle*  gtk_widget_get_style		(GtkWidget	*widget);
void	   gtk_widget_restore_default_style (GtkWidget	*widget);

/* Descend recursively and set rc-style on all widgets without user styles */
void       gtk_widget_reset_rc_styles   (GtkWidget      *widget);

/* Push/pop pairs, to change default values upon a widget's creation.
 * This will override the values that got set by the
 * gtk_widget_set_default_* () functions.
 */
void	     gtk_widget_push_style	    (GtkStyle	 *style);
void	     gtk_widget_push_colormap	    (GdkColormap *cmap);
void	     gtk_widget_push_visual	    (GdkVisual	 *visual);
void	     gtk_widget_push_composite_flag (void);
void	     gtk_widget_pop_composite_flag  (void);
void	     gtk_widget_pop_style	    (void);
void	     gtk_widget_pop_colormap	    (void);
void	     gtk_widget_pop_visual	    (void);

/* Set certain default values to be used at widget creation time.
 */
void	     gtk_widget_set_default_style    (GtkStyle	  *style);
void	     gtk_widget_set_default_colormap (GdkColormap *colormap);
void	     gtk_widget_set_default_visual   (GdkVisual	  *visual);
GtkStyle*    gtk_widget_get_default_style    (void);
GdkColormap* gtk_widget_get_default_colormap (void);
GdkVisual*   gtk_widget_get_default_visual   (void);

/* Counterpart to gdk_window_shape_combine_mask.
 */
void	     gtk_widget_shape_combine_mask (GtkWidget *widget,
					    GdkBitmap *shape_mask,
					    gint       offset_x,
					    gint       offset_y);

/* Compute a widget's path in the form "GtkWindow.MyLabel", and
 * return newly alocated strings.
 */
void	     gtk_widget_path		   (GtkWidget *widget,
					    guint     *path_length,
					    gchar    **path,
					    gchar    **path_reversed);
void	     gtk_widget_class_path	   (GtkWidget *widget,
					    guint     *path_length,
					    gchar    **path,
					    gchar    **path_reversed);

/* When you get a drag_enter event, you can use this to tell Gtk of other
 *  items that are to be dragged as well...
 */
void	     gtk_widget_dnd_drag_add (GtkWidget *widget);

/* These two functions enable drag and/or drop on a widget,
 *  and also let Gtk know what data types will be accepted (use MIME
 *  type naming, plus tacking "URL:" on the front for link dragging)
 */
void	     gtk_widget_dnd_drag_set (GtkWidget	    *widget,
				      guint8	     drag_enable,
				      gchar	   **type_accept_list,
				      guint	     numtypes);
void	     gtk_widget_dnd_drop_set (GtkWidget	    *widget,
				      guint8	     drop_enable,
				      gchar	   **type_accept_list,
				      guint	     numtypes,
				      guint8	     is_destructive_operation);

/* Used to reply to a DRAG_REQUEST event - if you don't want to 
 * give the data then pass in NULL for it 
 */
void	     gtk_widget_dnd_data_set (GtkWidget	    *widget,
				      GdkEvent	    *event,
				      gpointer	     data,
				      gulong	     data_numbytes);

/******************** WINDOWS ********************************/

GtkWidget* gtk_window_new                      (GtkWindowType        type);
void       gtk_window_set_title                (GtkWindow           *window,
						const gchar         *title);
void       gtk_window_set_wmclass              (GtkWindow           *window,
						const gchar         *wmclass_name,
						const gchar         *wmclass_class);
void       gtk_window_set_focus                (GtkWindow           *window,
						GtkWidget           *focus);
void       gtk_window_set_default              (GtkWindow           *window,
						GtkWidget           *defaultw);
void       gtk_window_set_policy               (GtkWindow           *window,
						gint                 allow_shrink,
						gint                 allow_grow,
						gint                 auto_shrink);
void       gtk_window_add_accel_group          (GtkWindow           *window,
						GtkAccelGroup	    *accel_group);
void       gtk_window_remove_accel_group       (GtkWindow           *window,
						GtkAccelGroup	    *accel_group);
void       gtk_window_position                 (GtkWindow           *window,
						GtkWindowPosition    position);
gint	   gtk_window_activate_focus	       (GtkWindow           *window);
gint	   gtk_window_activate_default	       (GtkWindow           *window);

/* If window is set modal, input will be grabbed when show and released when
 hide */
void       gtk_window_set_modal                (GtkWindow           *window,
                                                gboolean modal);








