/*
** wavwindow.h for Gmurf in Gmurf/gui
** 
** Made by Rmi Coupet
** Login   <inthy@sietch.inthy.fr>
** 
** Started on  Thu Mar 11 13:35:12 1999 Rmi Coupet
** Last update Thu Mar 18 18:28:02 1999 Rmi Coupet
*/


#ifndef __WAVWIN_H__

#define __WAVWIN_H__
#include <gdk/gdk.h>
#include "gui.h"
#include "waveditor.h"
#include "TempGmurf.h"
#include "playmode.h"
#include "Constants.h"
#include "Win_Aux.h"
#include "mix_sample.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define WAVWIN(obj)          GTK_CHECK_CAST (obj, wavwin_get_type (), Wavwin)
#define WAVWIN_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, wavwin_get_type (), WavwinClass)
#define IS_WAVWIN(obj)       GTK_CHECK_TYPE (obj, wavwin_get_type ())

  
typedef struct _Wavwin		Wavwin ;
typedef struct _WavwinClass	WavwinClass ;

struct		_Wavwin
{
  GtkVBox	vbox; /* type of the ancestor */
  
  GtkWidget	*wve[WAV_EDIT] ;

  int		is_the_button_pressed ;
  GtkWidget	*m_win ;
  GtkWidget	*toolbar ;
  GtkWidget	*menubar ;
  GtkWidget	*notebook ;
  GtkWidget	*play_button[WAVPLAYER_BUTTONS] ;
  GtkWidget	*toolbar_button[TOOLBAR_REPRESENTATION] ;
  GtkWidget	*navigation_button[NAVIGATION_BUTTONS] ;
  GtkWidget	*filters_button[FILTERS_BUTTONS] ;
  GtkWidget	*selection_button[SELECTION_BUTTONS] ;
  GtkWidget	*progress_bar ;
  GtkWidget	*chose_channel[CHANNELS] ;
  GtkWidget	*export_button ;
  GtkWidget	*invert_button ;
  t_tempgmurf	*tempgmurf ;
  t_playmode	*playmode ;
  Mixer_Sample	*ms_connected ;
  int		histo_active ;
  int		invert ;
};


struct		_WavwinClass
{
  GtkVBoxClass	parent_class;

  void		(* wavwin) (Wavwin *ww);
};

guint		wavwin_get_type			(void);
GtkWidget*	wavwin_new			(void);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __WAVWIN_H__ */

















